
import UIKit
import CloudKit

class CitiesViewController: UITableViewController {
    override func viewDidLoad() {
        super.viewDidLoad()
        let center = NotificationCenter.default
        let name = Notification.Name("Update Interface")
        center.addObserver(self, selector: #selector(updateInterface(notification:)), name: name, object: nil)
        
        AppData.readCities()
    }
    @objc func updateInterface(notification: Notification) {
        tableView.reloadData()
    }
    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return AppData.listCities.count
    }
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "citiesCell", for: indexPath)
        let record = AppData.listCities[indexPath.row]
        if let name = record["name"] as? String {
            cell.textLabel?.text = name
        }
        return cell
    }
    @IBAction func addCity(_ sender: UIBarButtonItem) {
        let alert = UIAlertController(title: "Insert City", message: nil, preferredStyle: .alert)
        let cancel = UIAlertAction(title: "Cancel", style: .cancel, handler: nil)
        alert.addAction(cancel)
        let action = UIAlertAction(title: "Save", style: .default, handler: { (action) in
            if let fields = alert.textFields {
                let name = fields[0].text!
                AppData.insertCity(name: name)
            }
        })
        alert.addAction(action)
        alert.addTextField(configurationHandler: nil)
        present(alert, animated: true, completion: nil)
    }
}
