
import UIKit
import CloudKit
import CoreData

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {
    var window: UIWindow?
    var container: NSPersistentContainer!
    var context: NSManagedObjectContext!
    
    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
        let userSettings = UserDefaults.standard
        let values = ["subscriptionSaved": false, "zoneCreated": false]
        userSettings.register(defaults: values)
        
        container = NSPersistentContainer(name: "places")
        container.loadPersistentStores(completionHandler: { (storeDescription, error) in
            if error != nil {
                print("Error")
            } else {
                self.context = self.container.viewContext
            }
        })
        application.registerForRemoteNotifications()
        AppData.checkUpdates(finishClosure: {(result) in return})
        
        return true
    }
    func application(_ application: UIApplication, didReceiveRemoteNotification userInfo: [AnyHashable : Any], fetchCompletionHandler completionHandler: @escaping (UIBackgroundFetchResult) -> Void) {
        let notification = CKNotification(fromRemoteNotificationDictionary: userInfo) as? CKDatabaseNotification
        if notification != nil {
            AppData.checkUpdates(finishClosure: { (result) in
                let mainQueue = OperationQueue.main
                mainQueue.addOperation({
                    completionHandler(result)
                })
            })
        }
    }
}
